-- Random EQ

-- Define properties
property("Background", COLOUR, 255,255,255) -- Background (default to white)
property("Foreground", COLOUR, 0,0,255) -- Foreground (default to Blue)
property("Bands", INTEGER, 5, 1) -- Number of bands (default to 5)
property("Rate",INTEGER,5,1) -- Effect rate (default to 5)
property("Seed", INTEGER, 500, 0) -- Seed for random number generator (default to 500)
property("Fade", FLOAT,0.10,0,1,2) -- % fade out at the top of the bar (default to 10%)

-- initialise the random number generator
math.randomseed(Seed)

-- Initialise variables and tables
last_frame = 0
frame_count = 1
count = 0
local heights = {}
local new_heights = {}

for i=0,Bands do
    heights[i] = math.floor(math.random(0,height))
end

function new_height() -- get a new height for the Bands by adding a random number between the negative height and the frame height - current height to the current height
    for i=0, Bands do
        new_heights[i] = heights[i] + math.floor(math.random((heights[i]*-1),(height-heights[i])))
    end
end
new_height()
-- get the band width
local band_width = width/Bands

-- the pixel function
function pixel(frame,x,y)
    if frame ~= last_frame then -- Is this a new frame or a new pixel? if new frame, set band heights
        if frame_count == Rate then -- If the frame count == the set Rate then set new band heights
            for i=0,Bands do  
                heights[i] = math.floor(heights[i] + ((new_heights[i]-heights[i])/(Rate)))
            end
            new_height() -- Set new heights
            frame_count = 1 -- 
        else -- Otherwise set the height to be a fractianal change 
            for i=0,Bands do  
                heights[i] = math.floor(heights[i] + ((new_heights[i]-heights[i])/Rate))
            end
            frame_count = frame_count + 1
        end
        last_frame = frame
    end
    -- get the band in which this pixel falls
    local band = math.floor(x/band_width)
    -- get the fraction through the effect
    local t = frame/frames
    -- get the height of the band in which this pixel falls
    local band_height = (heights[band])
    -- decide if this pixel is inside the band
    if (height-y < (band_height*(1-Fade))) then -- Is the pixel within the solid part of the bar
        return Foreground
    elseif (height-y <= (band_height)) then -- Is the pixel part of the fading section (interpolate colour from percentage through faded section, Foreground colour and Background colour)
        interp = 1-(band_height-(height-y))/(band_height*(Fade))
        return colour.interpolate(Foreground,Background,interp)
    else -- Not part of the band, set to the Background colour
        return Background
    end
end

--[[
Copyright 2016 Pharos Architectural Controls Limited. All rights reserved.

This sample content is made freely available for illustrative purposes only. Pharos Architectural Controls grants a non-exclusive copyright licence to use this sample content from which you can generate content tailored to your own specific needs for use with products from Pharos Architectural Controls. This sample content has not been thoroughly tested under all conditions and Pharos Architectural Controls cannot guarantee reliability or serviceability.

This sample content is provided "as is" without warranties of any kind. The implied warranties of non-infringement, merchantability and fitness for a particular purpose are expressly disclaimed. In no event shall Pharos Architectural Controls be liable to any party for direct, indirect, incidental or consequential damages arising from the use of this sample content.

For further information please contact support@pharoscontrols.com.
--]]